package zero1hd.rhythmbullet.graphics.ui.components;

import com.badlogic.gdx.assets.AssetManager;
import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.Pixmap;
import com.badlogic.gdx.graphics.Pixmap.Format;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.Sprite;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.utils.Disposable;

public class TitleBarVisualizer extends Group implements Disposable {
	private Visualizer hvisual;
	private Sprite backgroundBar;
	private Texture backgroundTexture;
	private Image titleImage;
	
	public TitleBarVisualizer(AssetManager assets) {
		if (assets == null) throw new  NullPointerException("TitleBarVisualizer requires assets manager... ITS NULL YOU FOOL");
		
		hvisual = new Visualizer();
		addActor(hvisual);
		
		Pixmap pixmap = new Pixmap(2, 2, Format.RGBA8888);
		pixmap.setColor(Color.WHITE);
		pixmap.fill();
		backgroundTexture  = new Texture(pixmap);
		pixmap.dispose();
		backgroundBar = new Sprite(backgroundTexture);
		
		titleImage = new Image(assets.get("title.png", Texture.class));
		addActor(titleImage);
		
		backgroundBar.setPosition(getX(), getY());
		backgroundBar.setRotation(getRotation());
		backgroundBar.setSize(getWidth(), getHeight());
		hvisual.setY(getHeight());
	}
	
	@Override
	public void act(float delta) {
		super.act(delta);
	}
	
	public Visualizer getHvisual() {
		return hvisual;
	}

	@Override
	public void dispose() {
		backgroundTexture.dispose();
		backgroundTexture = null;
	}
	
	@Override
	public void setColor(Color color) {
		backgroundBar.setColor(color);
		super.setColor(color);
	}
	
	@Override
	public void setColor(float r, float g, float b, float a) {
		backgroundBar.setColor(r, g, b, a);
		super.setColor(r, g, b, a);
	}
}
